using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Contabilidad._0_Modelos;
using System.Data.SqlClient;
using System.Threading;

namespace Exferia_Contabilidad._1_Datos
{
    public class CTA_PredefinidosLineas_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_CTA_PredefinidosLineas_Listado_Modelo> g_lst_INTERNO_CTA_PredefinidosLineas_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_CTA = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(CTA_PredefinidosLineas).Name), _lst_CamposConRelacionABuscar, -1,null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_CTA_PredefinidosLineas_Listado_Modelo != null) && (g_lst_INTERNO_CTA_PredefinidosLineas_Listado_Modelo.Count() > 0))
                {
                    lst_CTA = g_lst_INTERNO_CTA_PredefinidosLineas_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosLineas_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_CTA;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_CTA = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(CTA_PredefinidosLineas).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_CTA_PredefinidosLineas_Listado_Modelo != null) && (g_lst_INTERNO_CTA_PredefinidosLineas_Listado_Modelo.Count() > 0))
                {
                    dnm_CTA = g_lst_INTERNO_CTA_PredefinidosLineas_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosLineas_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_CTA;
        }

        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                string str_SQL =
                  " SELECT " +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.id) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.id) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.debeHaber) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.debeHaber) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.conceptoFijo) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.conceptoFijo) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.signoPositivo) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.signoPositivo) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.noBuscarenCuenta) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.noBuscarenCuenta) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.repetir) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.repetir) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.acumulado) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.acumulado) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.linea) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.linea) + "," +
                      //ids
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idDepartamento) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idDepartamento) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idMayor) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idMayor) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idPredefinidoAuxiliar) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoAuxiliar) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idPredefinidoConcepto_1) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_1) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idPredefinidoConcepto_2) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_2) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idPredefinidoConcepto_3) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_3) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idPredefinidoCuenta) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoCuenta) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idPredefinidoEntidad) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoEntidad) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idPredefinidoImporte) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoImporte) + "," +
                      //PredefinidoAuxiliar
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosAuxiliar_Codigo) + " = " + nameof(CTA_PredefinidosAuxiliares) + "." + nameof(CTA_PredefinidosAuxiliares.codigo) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosAuxiliar_Descripcion) + " = " + nameof(CTA_PredefinidosAuxiliares) + "." + nameof(CTA_PredefinidosAuxiliares.descripcion) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosAuxiliar_FechaBorrado) + " = " + nameof(CTA_PredefinidosAuxiliares) + "." + nameof(CTA_PredefinidosAuxiliares.fechaBorrado) + "," +
                      //PredefinidoConcepto1
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos1_Codigo) + " = AUX_1." + nameof(CTA_PredefinidosConceptos.codigo) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos1_Descripcion) + " = AUX_1." + nameof(CTA_PredefinidosConceptos.descripcion) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos1_FechaBorrado) + " = AUX_1." + nameof(CTA_PredefinidosConceptos.fechaBorrado) + "," +
                      //PredefinidoConcepto2
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos2_Codigo) + " = AUX_2." + nameof(CTA_PredefinidosConceptos.codigo) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos2_Descripcion) + " = AUX_2." + nameof(CTA_PredefinidosConceptos.descripcion) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos2_FechaBorrado) + " = AUX_2." + nameof(CTA_PredefinidosConceptos.fechaBorrado) + "," +
                      //PredefinidoConcepto3
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos3_Codigo) + " = AUX_3." + nameof(CTA_PredefinidosConceptos.codigo) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos3_Descripcion) + " = AUX_3." + nameof(CTA_PredefinidosConceptos.descripcion) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos3_FechaBorrado) + " = AUX_3." + nameof(CTA_PredefinidosConceptos.fechaBorrado) + "," +
                      //PredefinidosCuentas
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosCuentas_Codigo) + " = " + nameof(CTA_PredefinidosCuentas) + "." + nameof(CTA_PredefinidosCuentas.codigo) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosCuentas_Descripcion) + " = " + nameof(CTA_PredefinidosCuentas) + "." + nameof(CTA_PredefinidosCuentas.descripcion) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosCuentas_FechaBorrado) + " = " + nameof(CTA_PredefinidosCuentas) + "." + nameof(CTA_PredefinidosCuentas.fechaBorrado) + "," +
                      //PredefinidosEntidad
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosEntidad_Codigo) + " = " + nameof(CTA_PredefinidosEntidades) + "." + nameof(CTA_PredefinidosEntidades.codigo) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosEntidad_Descripcion) + " = " + nameof(CTA_PredefinidosEntidades) + "." + nameof(CTA_PredefinidosEntidades.descripcion) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosEntidad_FechaBorrado) + " = " + nameof(CTA_PredefinidosEntidades) + "." + nameof(CTA_PredefinidosEntidades.fechaBorrado) + "," +  
                      //PredefinidosImporte
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosImporte_Codigo) + " = " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.codigo) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosImporte_Descripcion) + " = " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.descripcion) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosImporte_FechaBorrado) + " = " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.fechaBorrado) + "," +
                      //Mayor
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.Mayor_Codigo) + " = " + nameof(CTA_Mayor) + "." + nameof(CTA_Mayor.codigo) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.Mayor_Descripcion) + " = " + nameof(CTA_Mayor) + "." + nameof(CTA_Mayor.descripcion) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.Mayor_FechaBorrado) + " = " + nameof(CTA_Mayor) + "." + nameof(CTA_Mayor.fechaBorrado) + "," +
                      //Departamento
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.Departamento_Codigo) + " = " + nameof(CTA_Departamentos) + "." + nameof(CTA_Departamentos.codigo) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.Departamento_Descripcion) + " = " + nameof(CTA_Departamentos) + "." + nameof(CTA_Departamentos.descripcion) + "," +
                      nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.Departamento_FechaBorrado) + " = " + nameof(CTA_Departamentos) + "." + nameof(CTA_Departamentos.fechaBorrado) +   
                 " FROM " + nameof(CTA_PredefinidosLineas) +
                    //PredefinidosAuxiliar
                    " LEFT JOIN " + nameof(CTA_PredefinidosAuxiliares) + " ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoAuxiliar) + "=" + nameof(CTA_PredefinidosAuxiliares) + "." + nameof(CTA_PredefinidosAuxiliares.id) +
                    //PredefinidosConceptos1
                    " LEFT JOIN " + nameof(CTA_PredefinidosConceptos) + " AS AUX_1 ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_1) + "=AUX_1." + nameof(CTA_PredefinidosConceptos.id) +
                    //PredefinidosConceptos2
                    " LEFT JOIN " + nameof(CTA_PredefinidosConceptos) + " AS AUX_2 ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_2) + "=AUX_2." + nameof(CTA_PredefinidosConceptos.id) +
                    //PredefinidosConceptos3
                    " LEFT JOIN " + nameof(CTA_PredefinidosConceptos) + " AS AUX_3 ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_3) + "=AUX_3." + nameof(CTA_PredefinidosConceptos.id) +
                    //PredefinidosCuentas
                    " LEFT JOIN " + nameof(CTA_PredefinidosCuentas) + " ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoCuenta) + "=" + nameof(CTA_PredefinidosCuentas) + "." + nameof(CTA_PredefinidosCuentas.id) +
                    //PredefinidosEntidad
                    " LEFT JOIN " + nameof(CTA_PredefinidosEntidades) + " ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoEntidad) + "=" + nameof(CTA_PredefinidosEntidades) + "." + nameof(CTA_PredefinidosEntidades.id) +
                    //PredefinidosImporte
                    " LEFT JOIN " + nameof(CTA_PredefinidosImportes) + " ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoImporte) + "=" + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.id) +
                    //Mayor
                    " LEFT JOIN " + nameof(CTA_Mayor) + " ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idMayor) + "=" + nameof(CTA_Mayor) + "." + nameof(CTA_Mayor.id) +
                    //Departamento
                    " LEFT JOIN " + nameof(CTA_Departamentos) + " ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idDepartamento) + "=" + nameof(CTA_Departamentos) + "." + nameof(CTA_Departamentos.id) +
                    " WHERE " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.fechaBorrado) + " IS null AND " +
                      (
                         (_lng_id > -1)
                             ? (nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.id) + " = " + _lng_id)
                             : " 1 = 1  "
                      );

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_lst_INTERNO_CTA_PredefinidosLineas_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTA_PredefinidosLineas_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosLineas_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }

        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 10;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                  " SELECT " +
                         nameof(CTA_PredefinidosLineas.id) + "," +
                         nameof(CTA_PredefinidosLineas.debeHaber) + "," +
                         nameof(CTA_PredefinidosLineas.linea) + "," +
                         nameof(CTA_PredefinidosLineas.conceptoFijo) + "," +
                         nameof(CTA_PredefinidosLineas.signoPositivo) + "," +
                         nameof(CTA_PredefinidosLineas.repetir) + "," +
                         nameof(CTA_PredefinidosLineas.noBuscarenCuenta) + "," +
                         nameof(CTA_PredefinidosLineas.acumulado) + "," +
                         nameof(CTA_PredefinidosLineas.fechaBorrado) + "," +
                         //ids
                         nameof(CTA_PredefinidosLineas.idPredefinidoCabecera) + "," +
                         nameof(CTA_PredefinidosLineas.idPredefinidoAuxiliar) + "," +
                         nameof(CTA_PredefinidosLineas.idPredefinidoCuenta) + "," +
                         nameof(CTA_PredefinidosLineas.idPredefinidoEntidad) + "," +
                         nameof(CTA_PredefinidosLineas.idPredefinidoImporte) + "," +
                         nameof(CTA_PredefinidosLineas.idMayor) + "," +
                         nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_1) + "," +
                         nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_2) + "," +
                         nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_3) + "," +
                         nameof(CTA_PredefinidosLineas.idDepartamento) +
               " FROM " + nameof(CTA_PredefinidosLineas) +
               " WHERE " + nameof(CTA_PredefinidosLineas.fechaBorrado) + " IS NULL AND "+
                           nameof(CTA_PredefinidosLineas.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<CTA_PredefinidosLineas>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //CTA_Departamentos ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idDepartamento != null)
                    {
                        ThreadStart obj_ThreadStart_DEPARTAMENTO = new ThreadStart(Obtener_Departamento_Modelo_Obtener);
                        Thread obj_Thread_DEPARTAMENTO = new Thread(obj_ThreadStart_DEPARTAMENTO);
                        obj_Thread_DEPARTAMENTO.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[0] = true;
                    }

                    //CTA_Mayor ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idMayor != null)
                    {
                        ThreadStart obj_ThreadStart_MAYOR = new ThreadStart(Obtener_Mayor_Modelo_Obtener);
                        Thread obj_Thread_MAYOR = new Thread(obj_ThreadStart_MAYOR);
                        obj_Thread_MAYOR.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[1] = true;
                    }

                    //CTA_PredefinidosAuxiliares ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idPredefinidoAuxiliar != null)
                    {
                        ThreadStart obj_ThreadStart_PREDEFINIDOAUXILIAR = new ThreadStart(Obtener_PredefinidoAuxiliar_Modelo_Obtener);
                        Thread obj_Thread_PREDEFINIDOAUXILIAR = new Thread(obj_ThreadStart_PREDEFINIDOAUXILIAR);
                        obj_Thread_PREDEFINIDOAUXILIAR.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[2] = true;
                    }

                    //CTA_PredefinidosConceptos1 ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idPredefinidoConcepto_1 != null)
                    {
                        ThreadStart obj_ThreadStart_PREDEFINIDOCONCEPTO1 = new ThreadStart(Obtener_PredefinidoConcepto1_Modelo_Obtener);
                        Thread obj_Thread_PREDEFINIDOCONCEPTO1 = new Thread(obj_ThreadStart_PREDEFINIDOCONCEPTO1);
                        obj_Thread_PREDEFINIDOCONCEPTO1.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[3] = true;
                    }

                    //CTA_PredefinidosConceptos2 ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idPredefinidoConcepto_2 != null)
                    {
                        ThreadStart obj_ThreadStart_PREDEFINIDOCONCEPTO2 = new ThreadStart(Obtener_PredefinidoConcepto2_Modelo_Obtener);
                        Thread obj_Thread_PREDEFINIDOCONCEPTO2 = new Thread(obj_ThreadStart_PREDEFINIDOCONCEPTO2);
                        obj_Thread_PREDEFINIDOCONCEPTO2.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[4] = true;
                    }

                    //CTA_PredefinidosConceptos3 ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idPredefinidoConcepto_3 != null)
                    {
                        ThreadStart obj_ThreadStart_PREDEFINIDOCONCEPTO3 = new ThreadStart(Obtener_PredefinidoConcepto3_Modelo_Obtener);
                        Thread obj_Thread_PREDEFINIDOCONCEPTO3 = new Thread(obj_ThreadStart_PREDEFINIDOCONCEPTO3);
                        obj_Thread_PREDEFINIDOCONCEPTO3.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[5] = true;
                    }

                    //CTA_PredefinidosCuentas ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idPredefinidoCuenta != null)
                    {
                        ThreadStart obj_ThreadStart_PREDEFINIDOCUENTA = new ThreadStart(Obtener_PredefinidoCuenta_Modelo_Obtener);
                        Thread obj_Thread_PREDEFINIDOCUENTA = new Thread(obj_ThreadStart_PREDEFINIDOCUENTA);
                        obj_Thread_PREDEFINIDOCUENTA.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[6] = true;
                    }

                    //CTA_PredefinidosEntidades ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idPredefinidoEntidad != null)
                    {
                        ThreadStart obj_ThreadStart_PREDEFINIDOENTIDAD = new ThreadStart(Obtener_PredefinidoEntidad_Modelo_Obtener);
                        Thread obj_Thread_PREDEFINIDOENTIDAD = new Thread(obj_ThreadStart_PREDEFINIDOENTIDAD);
                        obj_Thread_PREDEFINIDOENTIDAD.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[7] = true;
                    }

                    //CTA_PredefinidosImportes ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idPredefinidoImporte != null)
                    {
                        ThreadStart obj_ThreadStart_PREDEFINIDOIMPORTE = new ThreadStart(Obtener_PredefinidoImporte_Modelo_Obtener);
                        Thread obj_Thread_PREDEFINIDOIMPORTE = new Thread(obj_ThreadStart_PREDEFINIDOIMPORTE);
                        obj_Thread_PREDEFINIDOIMPORTE.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[8] = true;
                    }

                    //CTA_PredefinidosCabeceras ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idPredefinidoCabecera != null)
                    {
                        ThreadStart obj_ThreadStart_PREDEFINIDOCABECERA = new ThreadStart(Obtener_PredefinidoCabecera_Modelo_Obtener);
                        Thread obj_Thread_PREDEFINIDOCABECERA = new Thread(obj_ThreadStart_PREDEFINIDOCABECERA);
                        obj_Thread_PREDEFINIDOCABECERA.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[9] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion

            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosLineas_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_Departamento_Modelo_Obtener()
        {
            try
            {
                CTA_Departamentos_Datos obj_CTA_Departamentos_Datos = new CTA_Departamentos_Datos();
                g_dnm_Modelo_Obtener.CTA_Departamentos = obj_CTA_Departamentos_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idDepartamento, false);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_Mayor_Modelo_Obtener()
        {
            try
            {
                CTA_Mayor_Datos obj_CTA_Mayor_Datos = new CTA_Mayor_Datos();
                g_dnm_Modelo_Obtener.CTA_Mayor = obj_CTA_Mayor_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idMayor);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }
        private void Obtener_PredefinidoAuxiliar_Modelo_Obtener()
        {
            try
            {
                CTA_PredefinidosAuxiliares_Datos obj_CTA_PredefinidosAuxiliares_Datos = new CTA_PredefinidosAuxiliares_Datos();
                g_dnm_Modelo_Obtener.CTA_PredefinidosAuxiliares = obj_CTA_PredefinidosAuxiliares_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idPredefinidoAuxiliar);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[2] = true;
            }
        }
        private void Obtener_PredefinidoConcepto1_Modelo_Obtener()
        {
            try
            {
                CTA_PredefinidosConceptos_Datos obj_CTA_PredefinidosConceptos_Datos = new CTA_PredefinidosConceptos_Datos();
                g_dnm_Modelo_Obtener.CTA_PredefinidosConceptos = obj_CTA_PredefinidosConceptos_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idPredefinidoConcepto_1);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[3] = true;
            }
        }
        private void Obtener_PredefinidoConcepto2_Modelo_Obtener()
        {
            try
            {
                CTA_PredefinidosConceptos_Datos obj_CTA_PredefinidosConceptos_Datos = new CTA_PredefinidosConceptos_Datos();
                g_dnm_Modelo_Obtener.CTA_PredefinidosConceptos1 = obj_CTA_PredefinidosConceptos_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idPredefinidoConcepto_2);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[4] = true;
            }
        }
        private void Obtener_PredefinidoConcepto3_Modelo_Obtener()
        {
            try
            {
                CTA_PredefinidosConceptos_Datos obj_CTA_PredefinidosConceptos_Datos = new CTA_PredefinidosConceptos_Datos();
                g_dnm_Modelo_Obtener.CTA_PredefinidosConceptos2 = obj_CTA_PredefinidosConceptos_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idPredefinidoConcepto_3);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[5] = true;
            }
        }
        private void Obtener_PredefinidoCuenta_Modelo_Obtener()
        {
            try
            {
                CTA_PredefinidosCuentas_Datos obj_CTA_PredefinidosCuentas_Datos = new CTA_PredefinidosCuentas_Datos();
                g_dnm_Modelo_Obtener.CTA_PredefinidosCuentas = obj_CTA_PredefinidosCuentas_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idPredefinidoCuenta);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[6] = true;
            }
        }
        private void Obtener_PredefinidoEntidad_Modelo_Obtener()
        {
            try
            {
                CTA_PredefinidosEntidades_Datos obj_CTA_PredefinidosEntidades_Datos = new CTA_PredefinidosEntidades_Datos();
                g_dnm_Modelo_Obtener.CTA_PredefinidosEntidades = obj_CTA_PredefinidosEntidades_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idPredefinidoEntidad);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[7] = true;
            }
        }
        private void Obtener_PredefinidoImporte_Modelo_Obtener()
        {
            try
            {
                CTA_PredefinidosImportes_Datos obj_CTA_PredefinidosImportes_Datos = new CTA_PredefinidosImportes_Datos();
                g_dnm_Modelo_Obtener.CTA_PredefinidosImportes = obj_CTA_PredefinidosImportes_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idPredefinidoImporte);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[8] = true;
            }
        }
        private void Obtener_PredefinidoCabecera_Modelo_Obtener()
        {
            try
            {
                CTA_PredefinidosCabeceras_Datos obj_CTA_PredefinidosCabeceras_Datos = new CTA_PredefinidosCabeceras_Datos();
                g_dnm_Modelo_Obtener.CTA_PredefinidosCabeceras = obj_CTA_PredefinidosCabeceras_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idPredefinidoCabecera,false,false,false);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[9] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        #region Obtener Volcado
        //Listado 
        private List<CTA_PredefinidosAuxiliares> g_lst_CTA_PredefinidosAuxiliares = null;
        private List<CTA_PredefinidosEntidades> g_lst_CTA_PredefinidosEntidades = null;
        private List<CTA_PredefinidosImportes> g_lst_CTA_PredefinidosImportes = null;
        private List<CTA_PredefinidosCuentas> g_lst_CTA_PredefinidosCuentas = null;
        private List<CTA_PredefinidosConceptos> g_lst_CTA_PredefinidosConceptos = null;
        private List<CTA_Departamentos> g_lst_CTA_Departamentos = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado = 6;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado = new bool[g_int_TotalHilos_Modelo_Listado];

        private List<INTERNO_CTA_PredefinidosLineas_Volcado_Modelo> g_lst_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo=null;

        public List<INTERNO_CTA_PredefinidosLineas_Volcado_Modelo> Obtener_Volcado(long _lng_idPredefinidoCabecera)
        {
            Exferia_Entities obj_Exferia_Entities = null;


            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL = " SELECT " +
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.id) + " = " + nameof(CTA_PredefinidosLineas.id) + "," + 
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoCabecera) + " = " + nameof(CTA_PredefinidosLineas.idPredefinidoCabecera) + "," +
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoAuxiliar) + " = " + nameof(CTA_PredefinidosLineas.idPredefinidoAuxiliar) + "," +
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoEntidad) + " = " + nameof(CTA_PredefinidosLineas.idPredefinidoEntidad) + "," +
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoImporte) + " = " + nameof(CTA_PredefinidosLineas.idPredefinidoImporte) + "," +
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoCuenta) + " = " + nameof(CTA_PredefinidosLineas.idPredefinidoCuenta) + "," +
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.debeHaber) + " = " + nameof(CTA_PredefinidosLineas.debeHaber) + "," +
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.linea) + " = " + nameof(CTA_PredefinidosLineas.linea) + "," +
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idMayor) + " = " + nameof(CTA_PredefinidosLineas.idMayor) + "," +
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.conceptoFijo) + " = " + nameof(CTA_PredefinidosLineas.conceptoFijo) + "," +
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoConcepto_1) + " = " + nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_1) + "," + 
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoConcepto_2) + " = " + nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_2) + "," + 
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoConcepto_3) + " = " + nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_3) + "," +
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.signoPositivo) + " = " + nameof(CTA_PredefinidosLineas.signoPositivo) + "," +
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.repetir) + " = " + nameof(CTA_PredefinidosLineas.repetir) + "," +
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idDepartamento) + " = " + nameof(CTA_PredefinidosLineas.idDepartamento) + "," +
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.noBuscarenCuenta) + " = " + nameof(CTA_PredefinidosLineas.noBuscarenCuenta) + "," +
                                    nameof(INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.acumulado) + " = " + nameof(CTA_PredefinidosLineas.acumulado) + 
                                " FROM " + nameof(CTA_PredefinidosLineas) +
                                " WHERE " + nameof(CTA_PredefinidosLineas.fechaBorrado) + " IS NULL AND " +
                                            nameof(CTA_PredefinidosLineas.idPredefinidoCabecera) + "=@idPredefinidoCabecera";

                                
                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idPredefinidoCabecera",  _lng_idPredefinidoCabecera)
                };

                //Rellenar el modelo
                g_lst_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTA_PredefinidosLineas_Volcado_Modelo>(str_SQL, arr_Parametros).ToList();


                #region Rellenar tablas Relacionadas
                if (g_lst_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo != null && g_lst_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.Count > 0)
                {
                   
                    
                    #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Modelo_Listado[int_Contador] = false;
                    }

                    //CTA_PredefinidosAuxiliares #############################################
                    ThreadStart obj_ThreadStart_PREDEFINIDOSAUXILIARES = new ThreadStart(Obtener_PredefinidosAuxiliares_Modelo_Listado);
                    Thread obj_Thread_PREDEFINIDOSAUXILIARES = new Thread(obj_ThreadStart_PREDEFINIDOSAUXILIARES);
                    obj_Thread_PREDEFINIDOSAUXILIARES.Start();

                    //CTA_PredefinidosEntidades #############################################
                    ThreadStart obj_ThreadStart_PREDEFINIDOSENTIDADES = new ThreadStart(Obtener_PredefinidosEntidades_Modelo_Listado);
                    Thread obj_Thread_PREDEFINIDOSENTIDADES = new Thread(obj_ThreadStart_PREDEFINIDOSENTIDADES);
                    obj_Thread_PREDEFINIDOSENTIDADES.Start();

                    //CTA_PredefinidosImportes #############################################
                    ThreadStart obj_ThreadStart_PREDEFINIDOSIMPORTES = new ThreadStart(Obtener_PredefinidosImportes_Modelo_Listado);
                    Thread obj_Thread_PREDEFINIDOSIMPORTES = new Thread(obj_ThreadStart_PREDEFINIDOSIMPORTES);
                    obj_Thread_PREDEFINIDOSIMPORTES.Start();

                    //CTA_PredefinidosCuentas #############################################
                    ThreadStart obj_ThreadStart_PREDEFINIDOSCUENTAS = new ThreadStart(Obtener_PredefinidosCuentas_Modelo_Listado);
                    Thread obj_Thread_PREDEFINIDOSCUENTAS = new Thread(obj_ThreadStart_PREDEFINIDOSCUENTAS);
                    obj_Thread_PREDEFINIDOSCUENTAS.Start();

                    //CTA_PredefinidosConceptos #############################################
                    ThreadStart obj_ThreadStart_PREDEFINIDOSCONCEPTOS = new ThreadStart(Obtener_PredefinidosConceptos_Modelo_Listado);
                    Thread obj_Thread_PREDEFINIDOSCONCEPTOS = new Thread(obj_ThreadStart_PREDEFINIDOSCONCEPTOS);
                    obj_Thread_PREDEFINIDOSCONCEPTOS.Start();

                    //CTA_Departamentos #############################################
                    ThreadStart obj_ThreadStart_DEPARTAMENTOS = new ThreadStart(Obtener_Departamentos_Modelo_Listado);
                    Thread obj_Thread_DEPARTAMENTOS = new Thread(obj_ThreadStart_DEPARTAMENTOS);
                    obj_Thread_DEPARTAMENTOS.Start();



                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                    #endregion

                    #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                    foreach (INTERNO_CTA_PredefinidosLineas_Volcado_Modelo mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo in g_lst_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo)
                    {

                        //CTA_PredefinidosAuxiliares #############################################
                        if (mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoAuxiliar!=null &&
                            g_lst_CTA_PredefinidosAuxiliares != null &&
                            g_lst_CTA_PredefinidosAuxiliares.Count > 0)
                        {
                            mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.CTA_PredefinidosAuxiliares = g_lst_CTA_PredefinidosAuxiliares.Where(m => m.id == mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoAuxiliar.Value).FirstOrDefault();
                        }

                        //CTA_PredefinidosEntidades #############################################
                        if (mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoEntidad != null &&
                            g_lst_CTA_PredefinidosEntidades != null &&
                            g_lst_CTA_PredefinidosEntidades.Count > 0)
                        {
                            mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.CTA_PredefinidosEntidades = g_lst_CTA_PredefinidosEntidades.Where(m => m.id == mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoEntidad.Value).FirstOrDefault();
                        }

                        //CTA_PredefinidosImportes #############################################
                        if (g_lst_CTA_PredefinidosImportes != null &&
                            g_lst_CTA_PredefinidosImportes.Count > 0)
                        {
                            mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.CTA_PredefinidosImportes = g_lst_CTA_PredefinidosImportes.Where(m => m.id == mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoImporte).FirstOrDefault();
                        }

                        //CTA_PredefinidosCuentas #############################################
                        if (g_lst_CTA_PredefinidosCuentas != null &&
                            g_lst_CTA_PredefinidosCuentas.Count > 0)
                        {
                            mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.CTA_PredefinidosCuentas = g_lst_CTA_PredefinidosCuentas.Where(m => m.id == mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoCuenta).FirstOrDefault();
                        }

                        //CTA_PredefinidosConceptos #############################################
                        if (g_lst_CTA_PredefinidosConceptos != null &&
                            g_lst_CTA_PredefinidosConceptos.Count > 0)
                        {
                            //CTA_PredefinidosConceptos
                            if (mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoConcepto_1 != null)
                            {
                                mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.CTA_PredefinidosConceptos = g_lst_CTA_PredefinidosConceptos.Where(m => m.id == mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoConcepto_1.Value).FirstOrDefault();
                            }

                            //CTA_PredefinidosConceptos1
                            if (mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoConcepto_2 != null)
                            {
                                mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.CTA_PredefinidosConceptos1 = g_lst_CTA_PredefinidosConceptos.Where(m => m.id == mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoConcepto_2.Value).FirstOrDefault();
                            }

                            //CTA_PredefinidosConceptos2
                            if (mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoConcepto_3 != null)
                            {
                                mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.CTA_PredefinidosConceptos2 = g_lst_CTA_PredefinidosConceptos.Where(m => m.id == mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idPredefinidoConcepto_3.Value).FirstOrDefault();
                            }
                        }

                        //CTA_Departamentos #############################################
                        if (mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idDepartamento != null &&
                            g_lst_CTA_Departamentos != null &&
                            g_lst_CTA_Departamentos.Count > 0)
                        {
                            mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.CTA_Departamentos = g_lst_CTA_Departamentos.Where(m => m.id == mdl_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.idDepartamento.Value).FirstOrDefault();
                        }
                    }
                    #endregion
                }
                #endregion
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosLineas_Datos) + "/" + nameof(Obtener_Volcado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_lst_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo;
        }
        #region Tablas Relacionadas
        private void Obtener_PredefinidosAuxiliares_Modelo_Listado()
        {
            try
            {
                CTA_PredefinidosAuxiliares_Datos obj_CTA_PredefinidosAuxiliares_Datos = new CTA_PredefinidosAuxiliares_Datos();
                g_lst_CTA_PredefinidosAuxiliares = obj_CTA_PredefinidosAuxiliares_Datos.Obtener_ModeloListado_Por_Ids(g_lst_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.Where(m=>m.idPredefinidoAuxiliar!=null).Select(m => m.idPredefinidoAuxiliar.Value).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
            }
        }
        private void Obtener_PredefinidosEntidades_Modelo_Listado()
        {
            try
            {
                CTA_PredefinidosEntidades_Datos obj_CTA_PredefinidosEntidades_Datos = new CTA_PredefinidosEntidades_Datos();
                g_lst_CTA_PredefinidosEntidades = obj_CTA_PredefinidosEntidades_Datos.Obtener_ModeloListado_Por_Ids(g_lst_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.Where(m => m.idPredefinidoEntidad != null).Select(m => m.idPredefinidoEntidad.Value).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[1] = true;
            }
        }
        private void Obtener_PredefinidosImportes_Modelo_Listado()
        {
            try
            {
                CTA_PredefinidosImportes_Datos obj_CTA_PredefinidosImportes_Datos = new CTA_PredefinidosImportes_Datos();
                g_lst_CTA_PredefinidosImportes = obj_CTA_PredefinidosImportes_Datos.Obtener_ModeloListado_Por_Ids(g_lst_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.Select(m => m.idPredefinidoImporte).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[2] = true;
            }
        }
        private void Obtener_PredefinidosCuentas_Modelo_Listado()
        {
            try
            {
                CTA_PredefinidosCuentas_Datos obj_CTA_PredefinidosCuentas_Datos = new CTA_PredefinidosCuentas_Datos();
                g_lst_CTA_PredefinidosCuentas = obj_CTA_PredefinidosCuentas_Datos.Obtener_ModeloListado_Por_Ids(g_lst_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.Select(m => m.idPredefinidoCuenta).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[3] = true;
            }
        }
        private void Obtener_PredefinidosConceptos_Modelo_Listado()
        {
            try
            {
                CTA_PredefinidosConceptos_Datos obj_CTA_PredefinidosConceptos_Datos = new CTA_PredefinidosConceptos_Datos();

                List<long> lst_ids = new List<long>();

                //Conceptos_1
                List<long> lst_ids_AUX_1 = g_lst_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.Where(m=>m.idPredefinidoConcepto_1!=null).Select(m => m.idPredefinidoConcepto_1.Value).ToList();
                if (lst_ids_AUX_1!=null && lst_ids_AUX_1.Count>0)
                {
                    lst_ids.AddRange(lst_ids_AUX_1);
                }

                //Conceptos_2
                List<long> lst_ids_AUX_2 = g_lst_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.Where(m => m.idPredefinidoConcepto_2 != null).Select(m => m.idPredefinidoConcepto_2.Value).ToList();
                if (lst_ids_AUX_2 != null && lst_ids_AUX_2.Count > 0)
                {
                    lst_ids.AddRange(lst_ids_AUX_2);
                }

                //Conceptos_3
                List<long> lst_ids_AUX_3 = g_lst_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.Where(m => m.idPredefinidoConcepto_3 != null).Select(m => m.idPredefinidoConcepto_3.Value).ToList();
                if (lst_ids_AUX_3 != null && lst_ids_AUX_3.Count > 0)
                {
                    lst_ids.AddRange(lst_ids_AUX_3);
                }


                g_lst_CTA_PredefinidosConceptos = obj_CTA_PredefinidosConceptos_Datos.Obtener_ModeloListado_Por_Ids(lst_ids);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[4] = true;
            }
        }
        private void Obtener_Departamentos_Modelo_Listado()
        {
            try
            {
                CTA_Departamentos_Datos obj_CTA_Departamentos_Datos = new CTA_Departamentos_Datos();
                g_lst_CTA_Departamentos = obj_CTA_Departamentos_Datos.Obtener_ModeloListado_Por_Ids(g_lst_INTERNO_CTA_PredefinidosLineas_Volcado_Modelo.Where(m=>m.idDepartamento!=null).Select(m => m.idDepartamento.Value).ToList(),false);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[5] = true;
            }
        }
        #endregion
        #endregion

        #region Obtener Interno Modelo Listado
        public List<INTERNO_CTA_PredefinidosLineas_Listado_Modelo> g_lst_INTERNO_CTA_PredefinidosLineas_Listado_Modelo_POR_CABECERA = null;

        public List<INTERNO_CTA_PredefinidosLineas_Listado_Modelo> Obtener_Listado_PorPredefinidoCabecera(long _lng_idPredefinidoCabecera)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                 " SELECT " +
                     //CTA_Mayor
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.id) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.id) + "," +
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.debeHaber) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.debeHaber) + "," +
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.conceptoFijo) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.conceptoFijo) + "," +
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.signoPositivo) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.signoPositivo) + "," +
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.noBuscarenCuenta) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.noBuscarenCuenta) + "," +
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.repetir) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.repetir) + "," +
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.linea) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.linea) + "," +
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.acumulado) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.acumulado) + "," +
                     //ids
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idDepartamento) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idDepartamento) + "," +
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idMayor) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idMayor) + "," +
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idPredefinidoAuxiliar) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoAuxiliar) + "," +
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idPredefinidoConcepto_1) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_1) + "," +
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idPredefinidoConcepto_2) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_2) + "," +
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idPredefinidoConcepto_3) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_3) + "," +
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idPredefinidoCuenta) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoCuenta) + "," +
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idPredefinidoEntidad) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoEntidad) + "," +
                     nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.idPredefinidoImporte) + " = " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoImporte) + "," +
                    //PredefinidoAuxiliar
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosAuxiliar_Codigo) + " = " + nameof(CTA_PredefinidosAuxiliares) + "." + nameof(CTA_PredefinidosAuxiliares.codigo) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosAuxiliar_Descripcion) + " = " + nameof(CTA_PredefinidosAuxiliares) + "." + nameof(CTA_PredefinidosAuxiliares.descripcion) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosAuxiliar_FechaBorrado) + " = " + nameof(CTA_PredefinidosAuxiliares) + "." + nameof(CTA_PredefinidosAuxiliares.fechaBorrado) + "," +
                    //PredefinidoConcepto1
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos1_Codigo) + " = AUX_1." + nameof(CTA_PredefinidosConceptos.codigo) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos1_Descripcion) + " = AUX_1." + nameof(CTA_PredefinidosConceptos.descripcion) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos1_FechaBorrado) + " = AUX_1." + nameof(CTA_PredefinidosConceptos.fechaBorrado) + "," +
                    //PredefinidoConcepto2
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos2_Codigo) + " = AUX_2." + nameof(CTA_PredefinidosConceptos.codigo) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos2_Descripcion) + " = AUX_2." + nameof(CTA_PredefinidosConceptos.descripcion) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos2_FechaBorrado) + " = AUX_2." + nameof(CTA_PredefinidosConceptos.fechaBorrado) + "," +
                    //PredefinidoConcepto3
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos3_Codigo) + " = AUX_3." + nameof(CTA_PredefinidosConceptos.codigo) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos3_Descripcion) + " = AUX_3." + nameof(CTA_PredefinidosConceptos.descripcion) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosConceptos3_FechaBorrado) + " = AUX_3." + nameof(CTA_PredefinidosConceptos.fechaBorrado) + "," +
                    //PredefinidosCuentas
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosCuentas_Codigo) + " = " + nameof(CTA_PredefinidosCuentas) + "." + nameof(CTA_PredefinidosCuentas.codigo) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosCuentas_Descripcion) + " = " + nameof(CTA_PredefinidosCuentas) + "." + nameof(CTA_PredefinidosCuentas.descripcion) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosCuentas_FechaBorrado) + " = " + nameof(CTA_PredefinidosCuentas) + "." + nameof(CTA_PredefinidosCuentas.fechaBorrado) + "," +
                    //PredefinidosEntidad
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosEntidad_Codigo) + " = " + nameof(CTA_PredefinidosEntidades) + "." + nameof(CTA_PredefinidosEntidades.codigo) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosEntidad_Descripcion) + " = " + nameof(CTA_PredefinidosEntidades) + "." + nameof(CTA_PredefinidosEntidades.descripcion) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosEntidad_FechaBorrado) + " = " + nameof(CTA_PredefinidosEntidades) + "." + nameof(CTA_PredefinidosEntidades.fechaBorrado) + "," +
                    //PredefinidosImporte
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosImporte_Codigo) + " = " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.codigo) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosImporte_Descripcion) + " = " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.descripcion) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.PredefinidosImporte_FechaBorrado) + " = " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.fechaBorrado) + "," +
                    //Mayor
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.Mayor_Codigo) + " = " + nameof(CTA_Mayor) + "." + nameof(CTA_Mayor.codigo) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.Mayor_Descripcion) + " = " + nameof(CTA_Mayor) + "." + nameof(CTA_Mayor.descripcion) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.Mayor_FechaBorrado) + " = " + nameof(CTA_Mayor) + "." + nameof(CTA_Mayor.fechaBorrado) + "," +
                    //Departamento
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.Departamento_Codigo) + " = " + nameof(CTA_Departamentos) + "." + nameof(CTA_Departamentos.codigo) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.Departamento_Descripcion) + " = " + nameof(CTA_Departamentos) + "." + nameof(CTA_Departamentos.descripcion) + "," +
                    nameof(INTERNO_CTA_PredefinidosLineas_Listado_Modelo.Departamento_FechaBorrado) + " = " + nameof(CTA_Departamentos) + "." + nameof(CTA_Departamentos.fechaBorrado) +
                " FROM " + nameof(CTA_PredefinidosLineas) +
                    //PredefinidosAuxiliares
                    " LEFT JOIN " + nameof(CTA_PredefinidosAuxiliares) + " ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoAuxiliar) + "=" + nameof(CTA_PredefinidosAuxiliares) + "." + nameof(CTA_PredefinidosAuxiliares.id) +
                    //PredefinidosConceptos1
                    " LEFT JOIN " + nameof(CTA_PredefinidosConceptos) + " AS AUX_1 ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_1) + "=AUX_1." + nameof(CTA_PredefinidosConceptos.id) +
                    //PredefinidosConceptos2
                    " LEFT JOIN " + nameof(CTA_PredefinidosConceptos) + " AS AUX_2 ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_2) + "=AUX_2." + nameof(CTA_PredefinidosConceptos.id) +
                    //PredefinidosConceptos3
                    " LEFT JOIN " + nameof(CTA_PredefinidosConceptos) + " AS AUX_3 ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_3) + "=AUX_3." + nameof(CTA_PredefinidosConceptos.id) +
                    //PredefinidosCuentas
                    " LEFT JOIN " + nameof(CTA_PredefinidosCuentas) + " ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoCuenta) + "=" + nameof(CTA_PredefinidosCuentas) + "." + nameof(CTA_PredefinidosCuentas.id) +
                    //PredefinidosEntidad
                    " LEFT JOIN " + nameof(CTA_PredefinidosEntidades) + " ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoEntidad) + "=" + nameof(CTA_PredefinidosEntidades) + "." + nameof(CTA_PredefinidosEntidades.id) +
                    //PredefinidosImporte
                    " LEFT JOIN " + nameof(CTA_PredefinidosImportes) + " ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoImporte) + "=" + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.id) +
                   //Mayor
                   " LEFT JOIN " + nameof(CTA_Mayor) + " ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idMayor) + "=" + nameof(CTA_Mayor) + "." + nameof(CTA_Mayor.id) +
                   //Departamento
                   " LEFT JOIN " + nameof(CTA_Departamentos) + " ON " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idDepartamento) + "=" + nameof(CTA_Departamentos) + "." + nameof(CTA_Departamentos.id) +
                    " WHERE " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.fechaBorrado) + " IS null AND " +
                                nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoCabecera) + " =@idPredefinidoCabecera ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idPredefinidoCabecera",  _lng_idPredefinidoCabecera)
                };

                //Rellenar el Modelo
                g_lst_INTERNO_CTA_PredefinidosLineas_Listado_Modelo_POR_CABECERA = obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTA_PredefinidosLineas_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosLineas_Datos) + "/" + nameof(Obtener_Listado_PorPredefinidoCabecera), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_lst_INTERNO_CTA_PredefinidosLineas_Listado_Modelo_POR_CABECERA;
        }

        #endregion

        #endregion

        #region MODELOS

        #region Modelo Simple
        private CTA_PredefinidosLineas g_mdl_CTA_PredefinidosLineas = null;
        public CTA_PredefinidosLineas Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosLineas_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_CTA_PredefinidosLineas;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                               object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_mdl_CTA_PredefinidosLineas = obj_Exferia_Entities.Database.SqlQuery<CTA_PredefinidosLineas>(_str_SQL, _arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosLineas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();

            }
        }
        #endregion

        #region Modelo Listado
        private List<CTA_PredefinidosLineas> g_lst_CTA_PredefinidosLineas = null;
        public List<CTA_PredefinidosLineas> Obtener_ModeloListado_Por_idPredefinidoCabecera(long _lng_IdPredefinidoCAbecera)
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(CTA_PredefinidosLineas) + "." + nameof(CTA_PredefinidosLineas.idPredefinidoCabecera) + "=@idPredefinidoCabecera";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idPredefinidoCabecera",  _lng_IdPredefinidoCAbecera)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosLineas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_idPredefinidoCabecera), true);
            }

            return g_lst_CTA_PredefinidosLineas;
        }

        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                  object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_CTA_PredefinidosLineas = obj_Exferia_Entities.Database.SqlQuery<CTA_PredefinidosLineas>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosLineas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                     nameof(CTA_PredefinidosLineas.id) + " , " +
                     nameof(CTA_PredefinidosLineas.idPredefinidoCabecera) + " , " +
                     nameof(CTA_PredefinidosLineas.idPredefinidoAuxiliar) + " , " +
                     nameof(CTA_PredefinidosLineas.idPredefinidoEntidad) + " , " +
                     nameof(CTA_PredefinidosLineas.idPredefinidoImporte) + " , " +
                     nameof(CTA_PredefinidosLineas.idPredefinidoCuenta) + " , " +
                     nameof(CTA_PredefinidosLineas.debeHaber) + " , " +
                     nameof(CTA_PredefinidosLineas.linea) + " , " +
                     nameof(CTA_PredefinidosLineas.idMayor) + " , " +
                     nameof(CTA_PredefinidosLineas.conceptoFijo) + " , " +
                     nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_1) + " , " +
                     nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_2) + " , " +
                     nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_3) + " , " +
                     nameof(CTA_PredefinidosLineas.signoPositivo) + " , " +
                     nameof(CTA_PredefinidosLineas.repetir) + " , " +
                     nameof(CTA_PredefinidosLineas.idDepartamento) + " , " +
                     nameof(CTA_PredefinidosLineas.noBuscarenCuenta) + " , " +
                     nameof(CTA_PredefinidosLineas.acumulado) + " , " +
                     nameof(CTA_PredefinidosLineas.fechaBorrado) + 
                " FROM " + nameof(CTA_PredefinidosLineas);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                CTA_PredefinidosLineas mdl_CTA_PredefinidosLineas_AGrabar = (CTA_PredefinidosLineas)_mdl_obj;
                CTA_PredefinidosLineas mdl_CTA_PredefinidosLineas_DatosViejos = new CTA_PredefinidosLineas();

                // Ver si existe ######################################################################
                CTA_PredefinidosLineas mdl_CTA_PredefinidosLineas_Final = Obtener_Modelo_Por_Id(mdl_CTA_PredefinidosLineas_AGrabar.id);
                //#####################################################################################

                // Grabar Datos  
                var valorDevuelto = obj_Exferia_Entities.CTA_PredefinidosLineas.Where(m => m.id.Equals(mdl_CTA_PredefinidosLineas_AGrabar.id));

                //UPDATE
                if (mdl_CTA_PredefinidosLineas_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_CTA_PredefinidosLineas_Final, mdl_CTA_PredefinidosLineas_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_CTA_PredefinidosLineas_AGrabar, mdl_CTA_PredefinidosLineas_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(CTA_PredefinidosLineas) +
                                            " SET " +
                                                nameof(CTA_PredefinidosLineas.idPredefinidoCabecera) + "=@idPredefinidoCabecera," +
                                                nameof(CTA_PredefinidosLineas.idPredefinidoAuxiliar) + "=@idPredefinidoAuxiliar," +
                                                nameof(CTA_PredefinidosLineas.idPredefinidoEntidad) + "=@idPredefinidoEntidad," +
                                                nameof(CTA_PredefinidosLineas.idPredefinidoImporte) + "=@idPredefinidoImporte," +
                                                nameof(CTA_PredefinidosLineas.idPredefinidoCuenta) + "=@idPredefinidoCuenta," +
                                                nameof(CTA_PredefinidosLineas.debeHaber) + "=@debeHaber," +
                                                nameof(CTA_PredefinidosLineas.linea) + "=@linea," +
                                                nameof(CTA_PredefinidosLineas.idMayor) + "=@idMayor," +
                                                nameof(CTA_PredefinidosLineas.conceptoFijo) + "=@conceptoFijo," +
                                                nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_1) + "=@idPredefinidoConcepto_1," +
                                                nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_2) + "=@idPredefinidoConcepto_2," +
                                                nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_3) + "=@idPredefinidoConcepto_3," +
                                                nameof(CTA_PredefinidosLineas.signoPositivo) + "=@signoPositivo," +
                                                nameof(CTA_PredefinidosLineas.repetir) + "=@repetir," +
                                                nameof(CTA_PredefinidosLineas.idDepartamento) + "=@idDepartamento," +
                                                nameof(CTA_PredefinidosLineas.noBuscarenCuenta) + "=@noBuscarenCuenta," +
                                                nameof(CTA_PredefinidosLineas.acumulado) + "=@acumulado," +
                                                nameof(CTA_PredefinidosLineas.fechaBorrado) + "=@fechaBorrado" +
                                            " WHERE " +
                                                nameof(CTA_PredefinidosLineas.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                         new SqlParameter("@idPredefinidoCabecera",  mdl_CTA_PredefinidosLineas_Final.idPredefinidoCabecera),
                         mdl_CTA_PredefinidosLineas_Final.idPredefinidoAuxiliar != null
                            ?   new SqlParameter("@idPredefinidoAuxiliar", mdl_CTA_PredefinidosLineas_Final.idPredefinidoAuxiliar.Value)
                            :   new SqlParameter("@idPredefinidoAuxiliar",  DBNull.Value),
                         mdl_CTA_PredefinidosLineas_Final.idPredefinidoEntidad != null
                            ?   new SqlParameter("@idPredefinidoEntidad", mdl_CTA_PredefinidosLineas_Final.idPredefinidoEntidad.Value)
                            :   new SqlParameter("@idPredefinidoEntidad",  DBNull.Value),
                         new SqlParameter("@idPredefinidoImporte",  mdl_CTA_PredefinidosLineas_Final.idPredefinidoImporte),
                         new SqlParameter("@idPredefinidoCuenta",  mdl_CTA_PredefinidosLineas_Final.idPredefinidoCuenta),
                         new SqlParameter("@debeHaber",  mdl_CTA_PredefinidosLineas_Final.debeHaber),
                         new SqlParameter("@linea",  mdl_CTA_PredefinidosLineas_Final.linea),
                         mdl_CTA_PredefinidosLineas_Final.idMayor != null
                            ?   new SqlParameter("@idMayor", mdl_CTA_PredefinidosLineas_Final.idMayor.Value)
                            :   new SqlParameter("@idMayor",  DBNull.Value),
                         mdl_CTA_PredefinidosLineas_Final.conceptoFijo != null
                            ?   new SqlParameter("@conceptoFijo", mdl_CTA_PredefinidosLineas_Final.conceptoFijo)
                            :   new SqlParameter("@conceptoFijo",  DBNull.Value),
                         mdl_CTA_PredefinidosLineas_Final.idPredefinidoConcepto_1 != null
                            ?   new SqlParameter("@idPredefinidoConcepto_1", mdl_CTA_PredefinidosLineas_Final.idPredefinidoConcepto_1.Value)
                            :   new SqlParameter("@idPredefinidoConcepto_1",  DBNull.Value),
                        mdl_CTA_PredefinidosLineas_Final.idPredefinidoConcepto_2 != null
                            ?   new SqlParameter("@idPredefinidoConcepto_2", mdl_CTA_PredefinidosLineas_Final.idPredefinidoConcepto_2.Value)
                            :   new SqlParameter("@idPredefinidoConcepto_2",  DBNull.Value),
                        mdl_CTA_PredefinidosLineas_Final.idPredefinidoConcepto_3 != null
                            ?   new SqlParameter("@idPredefinidoConcepto_3", mdl_CTA_PredefinidosLineas_Final.idPredefinidoConcepto_3.Value)
                            :   new SqlParameter("@idPredefinidoConcepto_3",  DBNull.Value),
                        new SqlParameter("@signoPositivo",  mdl_CTA_PredefinidosLineas_Final.signoPositivo),
                        new SqlParameter("@repetir",  mdl_CTA_PredefinidosLineas_Final.repetir),
                        mdl_CTA_PredefinidosLineas_Final.idDepartamento != null
                            ?   new SqlParameter("@idDepartamento", mdl_CTA_PredefinidosLineas_Final.idDepartamento.Value)
                            :   new SqlParameter("@idDepartamento",  DBNull.Value),
                        mdl_CTA_PredefinidosLineas_Final.noBuscarenCuenta != null
                            ?   new SqlParameter("@noBuscarenCuenta", mdl_CTA_PredefinidosLineas_Final.noBuscarenCuenta.Value)
                            :   new SqlParameter("@noBuscarenCuenta",  DBNull.Value),
                        new SqlParameter("@acumulado",  mdl_CTA_PredefinidosLineas_Final.acumulado),
                        mdl_CTA_PredefinidosLineas_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_CTA_PredefinidosLineas_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id", mdl_CTA_PredefinidosLineas_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_CTA_PredefinidosLineas_Final.id;
                }
                //INSERT
                else
                {
                    mdl_CTA_PredefinidosLineas_Final = new CTA_PredefinidosLineas();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_CTA_PredefinidosLineas_AGrabar, mdl_CTA_PredefinidosLineas_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(CTA_PredefinidosLineas) +
                                               " (" +
                                                       nameof(CTA_PredefinidosLineas.idPredefinidoCabecera) + "," +
                                                       nameof(CTA_PredefinidosLineas.idPredefinidoAuxiliar) + "," +
                                                       nameof(CTA_PredefinidosLineas.idPredefinidoEntidad) + "," +
                                                       nameof(CTA_PredefinidosLineas.idPredefinidoImporte) + "," +
                                                       nameof(CTA_PredefinidosLineas.idPredefinidoCuenta) + "," +
                                                       nameof(CTA_PredefinidosLineas.debeHaber) + "," +
                                                       nameof(CTA_PredefinidosLineas.linea) + "," +
                                                       nameof(CTA_PredefinidosLineas.idMayor) + "," +
                                                       nameof(CTA_PredefinidosLineas.conceptoFijo) + "," +
                                                       nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_1) + "," +
                                                       nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_2) + "," +
                                                       nameof(CTA_PredefinidosLineas.idPredefinidoConcepto_3) + "," +
                                                       nameof(CTA_PredefinidosLineas.signoPositivo) + "," +
                                                       nameof(CTA_PredefinidosLineas.repetir) + "," +
                                                       nameof(CTA_PredefinidosLineas.idDepartamento) + "," +
                                                       nameof(CTA_PredefinidosLineas.noBuscarenCuenta) + "," +
                                                       nameof(CTA_PredefinidosLineas.acumulado) + "," +
                                                       nameof(CTA_PredefinidosLineas.fechaBorrado) +
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(CTA_PredefinidosLineas.id) +
                                               " VALUES " +
                                               " ( " +
                                                   "@idPredefinidoCabecera," +
                                                   "@idPredefinidoAuxiliar," +
                                                   "@idPredefinidoEntidad," +
                                                   "@idPredefinidoImporte," +
                                                   "@idPredefinidoCuenta," +
                                                   "@debeHaber," +
                                                   "@linea," +
                                                   "@idMayor," +
                                                   "@conceptoFijo," +
                                                   "@idPredefinidoConcepto_1," +
                                                   "@idPredefinidoConcepto_2," +
                                                   "@idPredefinidoConcepto_3," +
                                                   "@signoPositivo," +
                                                   "@repetir," +
                                                   "@idDepartamento," +
                                                   "@noBuscarenCuenta," +
                                                   "@acumulado," +
                                                   "@fechaBorrado" +
                                               " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idPredefinidoCabecera",  mdl_CTA_PredefinidosLineas_Final.idPredefinidoCabecera),
                         mdl_CTA_PredefinidosLineas_Final.idPredefinidoAuxiliar != null
                            ?   new SqlParameter("@idPredefinidoAuxiliar", mdl_CTA_PredefinidosLineas_Final.idPredefinidoAuxiliar.Value)
                            :   new SqlParameter("@idPredefinidoAuxiliar",  DBNull.Value),
                         mdl_CTA_PredefinidosLineas_Final.idPredefinidoEntidad != null
                            ?   new SqlParameter("@idPredefinidoEntidad", mdl_CTA_PredefinidosLineas_Final.idPredefinidoEntidad.Value)
                            :   new SqlParameter("@idPredefinidoEntidad",  DBNull.Value),
                         new SqlParameter("@idPredefinidoImporte",  mdl_CTA_PredefinidosLineas_Final.idPredefinidoImporte),
                         new SqlParameter("@idPredefinidoCuenta",  mdl_CTA_PredefinidosLineas_Final.idPredefinidoCuenta),
                         new SqlParameter("@debeHaber",  mdl_CTA_PredefinidosLineas_Final.debeHaber),
                         new SqlParameter("@linea",  mdl_CTA_PredefinidosLineas_Final.linea),
                         mdl_CTA_PredefinidosLineas_Final.idMayor != null
                            ?   new SqlParameter("@idMayor", mdl_CTA_PredefinidosLineas_Final.idMayor.Value)
                            :   new SqlParameter("@idMayor",  DBNull.Value),
                         mdl_CTA_PredefinidosLineas_Final.conceptoFijo != null
                            ?   new SqlParameter("@conceptoFijo", mdl_CTA_PredefinidosLineas_Final.conceptoFijo)
                            :   new SqlParameter("@conceptoFijo",  DBNull.Value),
                         mdl_CTA_PredefinidosLineas_Final.idPredefinidoConcepto_1 != null
                            ?   new SqlParameter("@idPredefinidoConcepto_1", mdl_CTA_PredefinidosLineas_Final.idPredefinidoConcepto_1.Value)
                            :   new SqlParameter("@idPredefinidoConcepto_1",  DBNull.Value),
                        mdl_CTA_PredefinidosLineas_Final.idPredefinidoConcepto_2 != null
                            ?   new SqlParameter("@idPredefinidoConcepto_2", mdl_CTA_PredefinidosLineas_Final.idPredefinidoConcepto_2.Value)
                            :   new SqlParameter("@idPredefinidoConcepto_2",  DBNull.Value),
                        mdl_CTA_PredefinidosLineas_Final.idPredefinidoConcepto_3 != null
                            ?   new SqlParameter("@idPredefinidoConcepto_3", mdl_CTA_PredefinidosLineas_Final.idPredefinidoConcepto_3.Value)
                            :   new SqlParameter("@idPredefinidoConcepto_3",  DBNull.Value),
                        new SqlParameter("@signoPositivo",  mdl_CTA_PredefinidosLineas_Final.signoPositivo),
                        new SqlParameter("@repetir",  mdl_CTA_PredefinidosLineas_Final.repetir),
                        mdl_CTA_PredefinidosLineas_Final.idDepartamento != null
                            ?   new SqlParameter("@idDepartamento", mdl_CTA_PredefinidosLineas_Final.idDepartamento.Value)
                            :   new SqlParameter("@idDepartamento",  DBNull.Value),
                        mdl_CTA_PredefinidosLineas_Final.noBuscarenCuenta != null
                            ?   new SqlParameter("@noBuscarenCuenta", mdl_CTA_PredefinidosLineas_Final.noBuscarenCuenta.Value)
                            :   new SqlParameter("@noBuscarenCuenta",  DBNull.Value),
                        new SqlParameter("@acumulado",  mdl_CTA_PredefinidosLineas_Final.acumulado),
                        mdl_CTA_PredefinidosLineas_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_CTA_PredefinidosLineas_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(CTA_PredefinidosLineas_Datos), mdl_CTA_PredefinidosLineas_DatosViejos, mdl_CTA_PredefinidosLineas_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosLineas_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            bool bol_ActualizarFechaBorrado = false;//Este campo se utiliza por si no se puede borrar, que actualice la fecha de borrado

            try
            {

                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                CTA_PredefinidosLineas mdl_CTA_PredefinidosLineas_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if(mdl_CTA_PredefinidosLineas_Final != null)
                {
                    //Se intenta borrar, si diera un error porque esta relacionado se graba la fecha de baja
                    try
                    {
                        #region Delete
                        string str_SQL_Delete = " DELETE FROM  " + nameof(CTA_PredefinidosLineas) +
                                                " WHERE " +
                                                    nameof(CTA_PredefinidosLineas.id) + "=@id";
                        //Parametros
                        object[] arr_Parametros_Delete = new object[]
                        {
                                new SqlParameter("@id", _lng_id)
                        };
                        #endregion

                        //Delete
                        obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                        //Grabar un registro de trazabailidad con los datos de la transaccion realizada.
                        Datos_Generales.USR_Trazabilidad_Grabar(typeof(CTA_PredefinidosLineas), null, mdl_CTA_PredefinidosLineas_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                    }
                    catch (Exception ex)
                    {
                        var sqlException = ex.GetBaseException() as SqlException;
                        if (sqlException != null)
                        {
                            if (sqlException.Errors.Count > 0)
                            {
                                switch (sqlException.Errors[0].Number)
                                {
                                    case Control_Errores.G_INT_ERRORCONTROLADO_BORRAR_CONFLICTO_CLAVEFORANEA: // Foreign Key violation
                                        bol_ActualizarFechaBorrado = true;
                                        break;
                                    default:
                                        throw;
                                }
                            }
                        }
                        else
                        {
                            throw;
                        }
                    }

                    //Actualizar la fecha de baja, al no poder borrarlo por tener relaciones
                    if (bol_ActualizarFechaBorrado)
                    {
                        #region Update
                        string str_SQL_Update = " UPDATE " + nameof(CTA_PredefinidosLineas) +
                                                    " SET " +
                                                    nameof(CTA_PredefinidosLineas.fechaBorrado) + "=@fechaBorrado " +
                                                " WHERE " +
                                                    nameof(CTA_PredefinidosLineas.id) + "=@id";
                        //Parametros
                        object[] arr_Parametros_Update = new object[]
                        {
                                 new SqlParameter("@fechaBorrado",  DateTime.Now),
                                new SqlParameter("@id", _lng_id)
                        };
                        #endregion

                        //Update
                        obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                        //Grabar un registro de trazabilidad con los datos de la trasaccion realizada
                        Datos_Generales.USR_Trazabilidad_Grabar(typeof(CTA_PredefinidosLineas), null, mdl_CTA_PredefinidosLineas_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                    }
                }

                //Devolver tambien el Objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosLineas_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }

        public INTERNO_ValorDevuelto_Modelo Borrar_PorIdCabecera(long _lng_idPredefinidoCabecera)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                List<CTA_PredefinidosLineas> lst_CTA_PredefinidosLineas_ABORRAR = Obtener_ModeloListado_Por_idPredefinidoCabecera(_lng_idPredefinidoCabecera);
                if (lst_CTA_PredefinidosLineas_ABORRAR != null && lst_CTA_PredefinidosLineas_ABORRAR.Count() > 0)
                {
                    foreach (CTA_PredefinidosLineas mdl_CTA_PredefinidosLineas in lst_CTA_PredefinidosLineas_ABORRAR)
                    {
                        Borrar(mdl_CTA_PredefinidosLineas.id);
                    }
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosLineas_Datos) + "/" + nameof(Borrar_PorIdCabecera), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
